package net.peachjean.guice.resteasy;

import com.google.inject.Inject;
import org.jboss.resteasy.plugins.server.servlet.ConfigurationBootstrap;
import org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher;
import org.jboss.resteasy.plugins.server.servlet.ServletBootstrap;
import org.jboss.resteasy.plugins.server.servlet.ServletContainerDispatcher;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

public class GuiceRestEasyDispatcher extends HttpServletDispatcher {

	private ConfigurationBootstrap bootstrap;
	private ServletConfig servletConfig;

	@Inject
	public GuiceRestEasyDispatcher(ConfigurationBootstrap bootstrap) {
		this.bootstrap = bootstrap;
	}

	@Override
	public void init(ServletConfig servletConfig) throws ServletException {
		this.servletConfig = servletConfig;
		servletContainerDispatcher = new ServletContainerDispatcher();
		servletContainerDispatcher.init(servletConfig.getServletContext(), bootstrap, this, this);
		servletContainerDispatcher.getDispatcher().getDefaultContextObjects().put(ServletConfig.class, servletConfig);
	}

	@Override
	public ServletConfig getServletConfig() {
		return this.servletConfig;
	}
}
